From 2cb5e8bcd7d8f8bab9e40d36e3ae411989d09b6c Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Apr 11 2017 12:51:54 +0000
Subject: [PATCH 8/9] Suggest users in the config panel


---

diff --git a/hubs/static/client/app/components/CompletionInput.jsx b/hubs/static/client/app/components/CompletionInput.jsx
index 9b8b581..a97fc7f 100644
--- a/hubs/static/client/app/components/CompletionInput.jsx
+++ b/hubs/static/client/app/components/CompletionInput.jsx
@@ -20,7 +20,6 @@ export default class CompletionInput extends React.Component {
     this.onChange = this.onChange.bind(this);
     this.onSuggestionsFetchRequested = this.onSuggestionsFetchRequested.bind(this);
     this.onSuggestionsClearRequested = this.onSuggestionsClearRequested.bind(this);
-    this.onSuggestionSelected = this.onSuggestionSelected.bind(this);
     this.loadFromServer = this.loadFromServer.bind(this);
   }
 
@@ -39,20 +38,18 @@ export default class CompletionInput extends React.Component {
     this.setState({
       value: newValue
     });
-  }
-
-  onSuggestionSelected(e, {suggestionValue}) {
     // Transmit a "fake" changed event to the parent, if asked to.
-    if (!this.props.onChange) { return; }
-    const mockedEvent = {
-      type: 'change',
-      target: {
-        type: 'input',
-        name: this.props.name,
-        value: suggestionValue,
-      },
+    if (this.props.onChange) {
+      const mockedEvent = {
+        type: 'change',
+        target: {
+          type: 'input',
+          name: this.props.name,
+          value: newValue,
+        },
+      }
+      this.props.onChange(mockedEvent);
     }
-    this.props.onChange(mockedEvent);
   }
 
   // Autosuggest will call this function every time you need to update
@@ -83,13 +80,16 @@ export default class CompletionInput extends React.Component {
       dataType: 'json',
       cache: false,
       success: function(data) {
-        this.setState({
-          suggestions: data.results,
-          loading: false
-        });
+        var suggestions = data.results;
+        if (this.props.filterResults) {
+          suggestions = suggestions.filter(this.props.filterResults);
+        }
+        this.setState({suggestions: suggestions});
       }.bind(this),
       error: function(xhr, status, err) {
         console.error(this.props.url, status, err.toString());
+      }.bind(this),
+      complete: function(xhr, status) {
         this.setState({loading: false});
       }.bind(this)
     });
@@ -111,13 +111,11 @@ export default class CompletionInput extends React.Component {
     const renderSuggestion = suggestion => suggestion;
     // Autosuggest will pass through all these props to the input element.
     const inputProps = {
-      //placeholder: 'Type a programming language',
-      name: this.props.name,
       className: "form-control",
       value: this.state.value,
-      placeholder: this.props.placeholder,
       onChange: this.onChange,
     };
+    Object.assign(inputProps, this.props.inputProps);
 
     // Render the widget.
     return (
@@ -126,23 +124,21 @@ export default class CompletionInput extends React.Component {
           suggestions={this.state.suggestions}
           onSuggestionsFetchRequested={this.onSuggestionsFetchRequested}
           onSuggestionsClearRequested={this.onSuggestionsClearRequested}
-          onSuggestionSelected={this.onSuggestionSelected}
           getSuggestionValue={getSuggestionValue}
           renderSuggestion={renderSuggestion}
           inputProps={inputProps}
         />
-        { this.state.loading ?
-          <span className="form-control-feedback">
-            <img src={this.props.spinner} />
-          </span>
-        : null }
+        <div
+          className="loading-circle"
+          style={this.state.loading ? {display: "block"} : {}}
+          ></div>
       </div>
     );
   }
 
 }
 CompletionInput.defaultProps = {
-    placeholder: "",
+    inputProps: {},
     queryDelay: 800,
 };
 
diff --git a/hubs/static/client/app/core/HubConfig.jsx b/hubs/static/client/app/core/HubConfig.jsx
index fca9e33..f3993d7 100644
--- a/hubs/static/client/app/core/HubConfig.jsx
+++ b/hubs/static/client/app/core/HubConfig.jsx
@@ -70,7 +70,7 @@ export default class HubConfig extends React.Component {
 
   getRequestParams() {
     return {
-      url: this.props.url,
+      url: this.props.urls.config,
       dataType: 'json',
       cache: false,
       success: function(data) {
@@ -93,7 +93,7 @@ export default class HubConfig extends React.Component {
       error: function(xhr, status, err) {
         var msg = err.toString();
         if (!msg) { msg = "Error communicating with the server"; }
-        console.error(this.props.url, status, msg);
+        console.error(this.props.urls.config, status, msg);
         this.setState({error: msg});
       }.bind(this),
       complete: function(xhr, status) {
@@ -133,7 +133,6 @@ export default class HubConfig extends React.Component {
   }
 
   handleUserChange(username, role) {
-    console.log("new role", username, role);
     var data = {username: username, role: role};
     this.pushState(data, "role_change");
   }
@@ -195,6 +194,7 @@ export default class HubConfig extends React.Component {
                       handleChange={this.handleUserChange}
                       tabTitle={<FormattedMessage {...messages.owners} />}
                       loading={this.state.loading}
+                      urls={this.props.urls}
                       />
                     <UserPanel
                       users={this.state.users.member}
@@ -203,6 +203,7 @@ export default class HubConfig extends React.Component {
                       handleChange={this.handleUserChange}
                       tabTitle={<FormattedMessage {...messages.members} />}
                       loading={this.state.loading}
+                      urls={this.props.urls}
                       />
                     <ChatPanel
                       hubConfig={this.state.hubConfig}
diff --git a/hubs/static/client/app/core/HubConfigPanelUser.jsx b/hubs/static/client/app/core/HubConfigPanelUser.jsx
index d913c79..3565760 100644
--- a/hubs/static/client/app/core/HubConfigPanelUser.jsx
+++ b/hubs/static/client/app/core/HubConfigPanelUser.jsx
@@ -1,5 +1,6 @@
 import React from 'react';
 import {
+  injectIntl,
   defineMessages,
   FormattedMessage,
   } from 'react-intl';
@@ -48,6 +49,7 @@ export default class UserPanel extends React.Component {
     this.handleAdd = this.handleAdd.bind(this);
     this.handleAddInputChange = this.handleAddInputChange.bind(this);
     this.handleChange = this.handleChange.bind(this);
+    this.filterSuggestedUsers = this.filterSuggestedUsers.bind(this);
   }
 
   handleAdd(e) {
@@ -67,6 +69,11 @@ export default class UserPanel extends React.Component {
     this.props.handleChange(e.target.name, e.target.value);
   }
 
+  filterSuggestedUsers(user) {
+    // Only suggest non-members.
+    return (this.props.users.indexOf(user) === -1);
+  }
+
   render() {
     var users = this.props.users.map(function(user) {
       return (
@@ -99,27 +106,58 @@ export default class UserPanel extends React.Component {
         );
     }.bind(this));
 
+    const IntlCompletionInput = injectIntl(function(props) {
+        return (
+          <CompletionInput
+            inputProps={{
+              name: "username",
+              placeholder: props.intl.formatMessage(messages.add_user),
+            }}
+            url={(
+              props.urls.suggestUsers
+              + "?exclude-role=" + props.role
+            )}
+            onChange={this.handleAddInputChange}
+            />
+            );
+    }.bind(this));
+
     return (
       <div>
         <h3>{this.props.tabTitle}</h3>
-        <p className="text-muted">[Membership requests will be shown here]</p>
-        <hr />
+        {(this.props.role == "member") &&
+          <div>
+            <p className="text-muted">
+              [Membership requests will be shown here]
+            </p>
+            <hr />
+          </div>
+        }
         <form className="form-inline" onSubmit={this.handleAdd}
               style={{marginBottom: "1em"}}>
           <div className="form-group">
             <FormattedMessage {...messages.add_user}>
-              {(value) => (
-                <input
-                  type="text" className="form-control"
-                  name="username" placeholder={value}
+              {(message) => (
+                <CompletionInput
+                  inputProps={{
+                    name: "username",
+                    placeholder: message,
+                    value: this.state.addUsername,
+                  }}
+                  url={(
+                    this.props.urls.suggestUsers
+                    + "?exclude-role=" + this.props.role
+                  )}
                   onChange={this.handleAddInputChange}
-                  value={this.state.addUsername}
-                  style={{marginRight: "1em"}}
                   />
-                )}
+              )}
             </FormattedMessage>
-          </div>
-          <button className="btn btn-primary" disabled={this.props.loading}>
+            </div>
+          <button
+            className="btn btn-primary"
+            disabled={this.props.loading}
+            style={{marginLeft: "1em"}}
+            >
             <FormattedMessage {...messages.add} />
           </button>
         </form>
diff --git a/hubs/static/client/app/widgets/halp/Config.jsx b/hubs/static/client/app/widgets/halp/Config.jsx
index 9e81477..4a65107 100644
--- a/hubs/static/client/app/widgets/halp/Config.jsx
+++ b/hubs/static/client/app/widgets/halp/Config.jsx
@@ -125,10 +125,11 @@ export default class Config extends React.Component {
 
     const IntlCompletionInput = injectIntl((props) => (
         <CompletionInput
-          name="hub-add"
+          inputProps={{
+            name: "hub-add",
+            placeholder: props.intl.formatMessage(messages.placeholder),
+          }}
           url={props.urls.hubs}
-          spinner={props.urls.spinnerCircle}
-          placeholder={props.intl.formatMessage(messages.placeholder)}
           />
     ));
 
diff --git a/hubs/static/client/app/widgets/halp/ModalAllRequests.jsx b/hubs/static/client/app/widgets/halp/ModalAllRequests.jsx
index c3d13cd..cbb24b3 100644
--- a/hubs/static/client/app/widgets/halp/ModalAllRequests.jsx
+++ b/hubs/static/client/app/widgets/halp/ModalAllRequests.jsx
@@ -176,18 +176,25 @@ export default class ModalAllRequests extends Modal {
             </label>
             <div className="col-sm-8">
               <CompletionInput
-                name="people"
+                inputProps={{name: "people"}}
                 url={this.props.urls.requesters}
-                spinner={this.props.urls.spinnerCircle}
-                onChange={this.handleChange} />
+                onChange={this.handleChange}
+                />
             </div>
           </div>
           <div className="form-group">
             <div className="col-sm-offset-4 col-sm-8">
-              <button type="submit" className="btn btn-primary">
+              <button
+                type="submit"
+                className="btn btn-primary"
+                style={{marginRight: "1em"}}
+                >
                 <FormattedMessage {...messages.search_button} />
               </button>
-              { this.state.loading && <img style={{marginLeft: "2em"}} src={this.props.urls.spinner} /> }
+              <div
+                className="loading-circle"
+                style={this.state.loading ? {display: "inline-block"} : {}}
+                ></div>
             </div>
           </div>
         </form>
diff --git a/hubs/static/client/app/widgets/halp/Widget.jsx b/hubs/static/client/app/widgets/halp/Widget.jsx
index 71234a4..91a2fe8 100644
--- a/hubs/static/client/app/widgets/halp/Widget.jsx
+++ b/hubs/static/client/app/widgets/halp/Widget.jsx
@@ -147,7 +147,10 @@ export default class Widget extends React.Component {
             onHubClick={this.onHubClick}
             />
           { this.state.loading ?
-              <img className="center-block" src={this.props.urls.spinner} />
+              <div
+                className="loading-circle center-block"
+                style={{display: "block"}}
+                ></div>
             :
               <div className="requests">
                 {requestNodes}
diff --git a/hubs/tests/test_fedora_hubs_flask_api.py b/hubs/tests/test_fedora_hubs_flask_api.py
index a0a0d62..ed58d25 100644
--- a/hubs/tests/test_fedora_hubs_flask_api.py
+++ b/hubs/tests/test_fedora_hubs_flask_api.py
@@ -527,3 +527,61 @@ class HubsAPITest(hubs.tests.APPTest):
             url = '/decause/config?category=config'
             result = self.app.post(url, data={"summary": "Defaced!"})
         self.assertEqual(result.status_code, 403)
+
+    def test_hub_config_suggest_users_no_filter(self):
+        user = tests.FakeAuthorization('ralph')
+        expected = [
+            u.username for u in
+            hubs.models.User.query.order_by(
+                hubs.models.User.username
+            ).all()]
+        # Check without filter
+        with tests.auth_set(app, user):
+            url = '/ralph/config/suggest-users'
+            result = self.app.get(url)
+        self.assertEqual(result.status_code, 200)
+        result_data = json.loads(result.get_data(as_text=True))
+        self.assertEqual(result_data["status"], "OK")
+        self.assertListEqual(result_data["results"], expected)
+
+    def test_hub_config_suggest_users_filter_owners(self):
+        # Filters on owners
+        user = tests.FakeAuthorization('ralph')
+        expected = [
+            u.username for u in
+            hubs.models.User.query.order_by(
+                hubs.models.User.username
+            ).filter(
+                hubs.models.User.username != "ralph"
+            ).all()]
+        with tests.auth_set(app, user):
+            url = '/ralph/config/suggest-users?exclude-role=owner'
+            result = self.app.get(url)
+        self.assertEqual(result.status_code, 200)
+        result_data = json.loads(result.get_data(as_text=True))
+        self.assertEqual(result_data["status"], "OK")
+        self.assertListEqual(result_data["results"], expected)
+
+    def test_hub_config_suggest_users_filter_members(self):
+        # Filters on members
+        user = tests.FakeAuthorization('ralph')
+        hub = hubs.models.Hub.get('ralph')
+        decause = hubs.models.User.query.get("decause")
+        devyani7 = hubs.models.User.query.get("devyani7")
+        hub.subscribe(decause, "member")
+        hub.subscribe(devyani7, "member")
+        expected = [
+            u.username for u in
+            hubs.models.User.query.order_by(
+                hubs.models.User.username
+            ).filter(
+                hubs.models.User.username != "decause",
+                hubs.models.User.username != "devyani7"
+            ).all()]
+        with tests.auth_set(app, user):
+            url = '/ralph/config/suggest-users?exclude-role=member'
+            result = self.app.get(url)
+        self.assertEqual(result.status_code, 200)
+        result_data = json.loads(result.get_data(as_text=True))
+        self.assertEqual(result_data["status"], "OK")
+        self.assertListEqual(result_data["results"], expected)
diff --git a/hubs/views/hub.py b/hubs/views/hub.py
index c3ea5f4..d6d05f7 100644
--- a/hubs/views/hub.py
+++ b/hubs/views/hub.py
@@ -246,3 +246,37 @@ def hub_config_post_role_change(hub):
         hub.associations.append(hubs.models.Association(
             hub=hub, user=user, role=role))
     flask.g.db.commit()
+
+
+@app.route('/<name>/config/suggest-users')
+@login_required
+@require_hub_access("config", json=True)
+def hub_config_suggest_users(name):
+    MAX_SUGGESTS = 10
+    hub = get_hub(name)
+    results = flask.g.db.query(hubs.models.User.username)
+    query = flask.request.args.get("q")
+    if query:
+        results = results.filter(
+            hubs.models.User.username.ilike("%{}%".format(query))
+        )
+    exclude = flask.request.args.get("exclude-role")
+    if exclude:
+        exclude_query = flask.g.db.query(
+                hubs.models.User.username
+            ).join(
+                hubs.models.Association
+            ).join(
+                hubs.models.Hub
+            ).filter(
+                hubs.models.Hub.name == hub.name,
+                hubs.models.Association.role == exclude,
+            )
+        results = results.filter(
+            ~hubs.models.User.username.in_(exclude_query)
+            )
+    results = results.order_by(hubs.models.User.username).limit(MAX_SUGGESTS)
+    return flask.jsonify({
+        "status": "OK",
+        "results": [r[0] for r in results],
+        })

